Overview | Package | Class | Tree | Deprecated | Index | Help
| Copyright © 2000, 2008, Oracle and/or its affiliates. All rights reserved.
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.bea.netuix.application.manager
Interface IDesktopInstanceManager

All Known Subinterfaces:
  PortalCustomizationManager

    public interface IDesktopInstanceManager

This is the primary interface for performing persistent store operations on `DesktopInstance` objects. In general this interface provides coarse grain getters and fine grain setters.

It is important to note that all methods on this interface are fully internationalized and entitled. All `titles` and `descriptions` on the objects returned by these methods are internationalized to the preferred locale. Also, all methods are entitled, meaning if the caller does not have the required credentials the method may return a subset of the actual list or be unable to perform the specified function.

Most "Instances" can be thought of as objects tied to a desktop, An Admin has instances derived from the library Definition, and the "end user" has instances derived from the admin instance. Changes made via these APIs require a DesktopDefinitionId and the changes are scoped to that desktop. In other words changes made here do not affect the library or other Desktops. If the "visitorMode" on the customization Context is set the false (default) and the user executing the call is in the "Admin" or "PortalSystemAdministrator" role then these changes take affect at the admin level, and affect ALL users. If the visitorMode is false then the changes only affect the calling user.

See Also
  `CustomizationContext.setVisitorMode(boolean)`
  This interface is intended to be implemented only by Oracle Weblogic Portal. Oracle Systems reserves the right to add abstract methods to this interface without notice. Implementations of this interface by other parties must not be expected to compile without change in future versions of Oracle Weblogic Portal.

Method Summary
`void` | `deleteDesktopCustomizations(CustomizationContext customizationContext, String username, DesktopDefinitionId desktopDefinitionId)` Remove all the customizations for a particular user on a specific desktop.
`void` | `deleteDesktopCustomizations(String username)` Remove all the customizations for a particular user.
`DesktopView` | `getCustomizedDesktopView(CustomizationContext customizationContext, String webAppName, PortalPath portalPath, DesktopPath desktopPath)` Getter for returning an immutable deep `DesktopView`.
`DesktopInstance` | `getDesktopInstance(CustomizationContext customizationContext, DesktopInstanceId desktopInstanceId)` Getter for returning a `DesktopInstance` identified by the supplied instance id.
`DesktopInstance` | `getDesktopInstance(CustomizationContext customizationContext, String webAppName, PortalPath portalPath, DesktopPath desktopPath)` Getter for returning a `DesktopInstance` identified by the supplied webapp, portal path, and desktop path..
`DesktopView` | `getDesktopView(CustomizationContext customizationContext, DesktopInstanceId desktopInstanceId)` Getter for returning an immutable deep `DesktopView`.
`DesktopView` | `getDesktopView(CustomizationContext customizationContext, String webAppName, PortalPath portalPath, DesktopPath desktopPath)` Getter for returning an immutable deep `DesktopView`.
`DesktopView` | `getShallowDesktopView(CustomizationContext customizationContext, String webAppName, PortalPath portalPath, DesktopPath desktopPath)` Getter for returning an immutable shallow copy of a `DesktopView`.
`DesktopInstance` | `updateDesktopInstance(CustomizationContext customizationContext, DesktopInstance desktopInstance)` Update the persistent store for the supplied `DesktopInstance`.

Method Detail

### getDesktopView

    DesktopView getDesktopView(CustomizationContext customizationContext,
                               String webAppName,
                               PortalPath portalPath,
                               DesktopPath desktopPath)
                               throws RemoteException

  Getter for returning an immutable deep `DesktopView`. If the user has customized the desktop then this will return the user's specific instance. The `DesktopView` object, unlike the `DesktopDefinition` or the `DesktopInstance` objects contains a deep copy of all references to all child pages, books and so on. The `DesktopView` object, however is immutable.

  Please note that the CustomizationContext object passed to this method may be altered by the method.

  Parameters
    `customizationContext` - customization information such as preferred locales and desktopInstanceId. This object may be mutated by this method, so it is best to clone it before passing it as an argument here if you intend to use it again.
    `webAppName` - the name of the webapp
    `portalPath` - the partial portal path
    `desktopPath` - the partial desktop path
  Returns
    an immutable deep DesktopView object if one exists, otherwise null.
  Throws
    `RemoteException`
  See Also
    `IDesktopDefinitionManager.getDesktopView(com.bea.netuix.application.manager.CustomizationContext, com.bea.netuix.application.identifier.DesktopDefinitionId)`

### getShallowDesktopView

    DesktopView getShallowDesktopView(CustomizationContext customizationContext,
                                      String webAppName,
                                      PortalPath portalPath,
                                      DesktopPath desktopPath)
                                      throws RemoteException

  Getter for returning an immutable shallow copy of a `DesktopView`. If the user has customized the desktop then this will return the user's specific instance. The `DesktopView` object, unlike the `DesktopDefinition` or the `DesktopInstance` objects contains a reference to the main book. To recurse through child books and pages, use the paginated BookView.getPagedNavigableViews and PageView.getPagedPlaceableViews . The `DesktopView` object is immutable.

  Parameters
    `customizationContext` - customization information such as preferred locales and desktopInstanceId.
    `webAppName` - the name of the webapp
    `portalPath` - the partial portal path
    `desktopPath` - the partial desktop path
  Returns
    an immutable deep DesktopView object if one exists, otherwise null.
  Throws
    `RemoteException`
  See Also
    `IDesktopDefinitionManager.getDesktopView(com.bea.netuix.application.manager.CustomizationContext, com.bea.netuix.application.identifier.DesktopDefinitionId)`

### getCustomizedDesktopView

    DesktopView getCustomizedDesktopView(CustomizationContext customizationContext,
                                         String webAppName,
                                         PortalPath portalPath,
                                         DesktopPath desktopPath)
                                         throws RemoteException

  Getter for returning an immutable deep `DesktopView`. If the user has customized the desktop then this will return the user's specific instance otherwise null is returned. The `DesktopView` object, unlike the `DesktopDefinition` or the `DesktopInstance` objects contains a deep copy of all references to all child pages, books and so on. The `DesktopView` object, however is immutable.

  Parameters
    `customizationContext` - customization information such as preferred locales and desktopInstanceId.
    `webAppName` - the name of the webapp
    `portalPath` - the partial portal path
    `desktopPath` - the partial desktop path
  Returns
    an immutable deep DesktopView object if one exists, otherwise null.
  Throws
    `RemoteException`
  See Also
    `IDesktopDefinitionManager.getDesktopView(com.bea.netuix.application.manager.CustomizationContext, com.bea.netuix.application.identifier.DesktopDefinitionId)`

### getDesktopView

    DesktopView getDesktopView(CustomizationContext customizationContext,
                               DesktopInstanceId desktopInstanceId)
                               throws RemoteException

  Getter for returning an immutable deep `DesktopView`. The `DesktopView` object, unlike the `DesktopDefinition` or the `DesktopInstance` objects contains a deep copy of all references to all child pages, books and so on. The `DesktopView` object, however is immutable.

  Please note that the CustomizationContext object passed to this method may be altered by the method.

  Parameters
    `customizationContext` - customization information such as preferred locales and desktopInstanceId. This object may be mutated by this method, so it is best to clone it before passing it as an argument here if you intend to use it again.
    `desktopInstanceId` - the unique instance id (webapp/portlaPath/desktopPath) of the desktop.
  Returns
    an immutable deep DesktopView object if one exists, otherwise null.
  Throws
    `RemoteException`
  See Also
    `IDesktopDefinitionManager.getDesktopView(com.bea.netuix.application.manager.CustomizationContext, com.bea.netuix.application.identifier.DesktopDefinitionId)`

### getDesktopInstance

    DesktopInstance getDesktopInstance(CustomizationContext customizationContext,
                                       DesktopInstanceId desktopInstanceId)
                                       throws RemoteException

  Getter for returning a `DesktopInstance` identified by the supplied instance id.

  Parameters
    `customizationContext` - customization information such as preferred locales and desktopInstanceId.
    `desktopInstanceId` - the unique id of the instance to return
  Returns
    a fully populated internationalized `DesktopInstance` objects if it exist, otherwise null.
  Throws
    `RemoteException`

### getDesktopInstance

    DesktopInstance getDesktopInstance(CustomizationContext customizationContext,
                                       String webAppName,
                                       PortalPath portalPath,
                                       DesktopPath desktopPath)
                                       throws RemoteException

  Getter for returning a `DesktopInstance` identified by the supplied webapp, portal path, and desktop path..

  Parameters
    `customizationContext` - customization information such as preferred locales and desktopInstanceId.
    `webAppName` - the name of the webapp
    `portalPath` - the partial portal path
    `desktopPath` - the partial desktop path
  Returns
    a fully populated internationalized `DesktopInstance` objects if it exist, otherwise null.
  Throws
    `RemoteException`

### updateDesktopInstance

    DesktopInstance updateDesktopInstance(CustomizationContext customizationContext,
                                          DesktopInstance desktopInstance)
                                          throws RemoteException,
                                                 ObjectNotFoundException,
                                                 NotEntitledException

  Update the persistent store for the supplied `DesktopInstance`. All attributes of the DesktopInstance are updated in the persistent store.

  Parameters
    `desktopInstance` - the new desktop instance containing all the new data.
  Throws
    `ObjectNotFoundException` - the DesktopInstanceId specified in the desktopInstance is bogus.
    `NotEntitledException` - if the caller does not have the required permissions to update this object.
    `RemoteException`

### deleteDesktopCustomizations

    void deleteDesktopCustomizations(String username)
                                     throws RemoteException,
                                            NotEntitledException

  Remove all the customizations for a particular user. This method should be called when a user is deleted from the system, or you wish to remove all a user's customizations.

  Parameters
    `username` - the login name of the user.
  Throws
    `NotEntitledException` - if the caller does not have the required permissions to delete this customization
    `RemoteException`

### deleteDesktopCustomizations

    void deleteDesktopCustomizations(CustomizationContext customizationContext,
                                     String username,
                                     DesktopDefinitionId desktopDefinitionId)
                                     throws RemoteException,
                                            NotEntitledException

  Remove all the customizations for a particular user on a specific desktop.

  Parameters
    `username` - the login name of the user.
  Throws
    `NotEntitledException` - if the caller does not have the required permissions to delete this customization
    `RemoteException`

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2000, 2008, Oracle and/or its affiliates. All rights reserved.
Oracle is a registered trademark of Oracle Corporation and/or its affiliates.
Other names may be trademarks of their respective owners.